; 
    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\advapi32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\advapi32.lib
    includelib \masm32\lib\msvcrt.lib

    include \masm32\macros\macros.asm
    include \masm32\macros\ucmacros.asm

    NAME_SIZE EQU 1024

    SUBKEY EQU "SYSTEM\CurrentControlSet\Control\Nls\CodePage"

; 
    .data
      hKey          dd 0
      cbValueName   dd NAME_SIZE
      cbValueData   dd NAME_SIZE
      valueName     db NAME_SIZE dup(0)
      valueData     db NAME_SIZE dup(0) 
      subKey        db SUBKEY,0

      ;" j s ngremes aces"

      wstr dw 0E9h,' ','j',0E1h,' ',0E0h,'s',' ',0EDh,'n','g','r'
           dw 'e','m','e','s',' ','a','c',0E7h,0F5h,'e','s',0
      astr db 0E9h,' ','j',0E1h,' ',0E0h,'s',' ',0EDh,'n','g','r'
           db 'e','m','e','s',' ','a','c',0E7h,0F5h,'e','s',0
    .code
; 
start:
; 

    ; -----------------------------------------------
    ; Display the value names and the data for the
    ; values that are not assigned a null string.
    ; -----------------------------------------------

    invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,ADDR subKey,0,
                        KEY_ALL_ACCESS,ADDR hKey
    xor   ebx,ebx
    .REPEAT
        invoke RegEnumValue,hKey,ebx,ADDR valueName,ADDR cbValueName,
                            NULL,NULL,ADDR valueData,ADDR cbValueData
        Switch eax
          Case ERROR_NO_MORE_ITEMS
            .BREAK
          Case ERROR_MORE_DATA
            print chr$("name buffer too small",13,10)
            .BREAK
          Case ERROR_SUCCESS
            .IF valueData != 0
                print ADDR valueName,32,32
                print ADDR valueData,13,10
            .ENDIF            
          Default
            print chr$("unexpected error",13,10)
            .BREAK
        EndSw
        mov   cbValueName,NAME_SIZE
        mov   cbValueData,NAME_SIZE
        inc   ebx
    .UNTIL 0

    print chr$(13,10,13,10)

    ; -------------------------------------
    ; Show the unicode and ASCII strings.
    ; -------------------------------------

    invoke crt__putws, ADDR wstr
    print ADDR astr,13,10,13,10

    ; -----------------------------
    ; Show the current code page.
    ; -----------------------------

    invoke GetConsoleOutputCP
    print ustr$(eax),13,10

    ; ------------------------------------
    ; Change to the WinLatin1 code page.
    ; ------------------------------------

    invoke SetConsoleOutputCP,1252
    print ustr$(eax),13,10

    ; -----------------------------
    ; Show the current code page.
    ; -----------------------------

    invoke GetConsoleOutputCP
    print ustr$(eax),13,10,13,10

    ; -------------------------------------
    ; Show the unicode and ASCII strings.
    ; -------------------------------------

    invoke crt__putws, ADDR wstr
    print ADDR astr,13,10,13,10

    ; --------------------------------
    ; Show the ASCII string as ANSI.
    ; --------------------------------

    MsgBox 0,ADDR astr,"ANSI",MB_OK

    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 
end start




